/*
 * Desenha um objeto em MRUV.
 * O usurio pode controlar a intensidade da fora, a massa do
 * objeto, e a variao do tempo.
 * Oferece barras de rolagem.
 */



import java.awt.event.*;
import java.awt.*;
import java.lang.*;



class painel_controles extends Panel implements ActionListener {



    TextField m_e_massa;
    TextField m_e_forca;
    TextField m_e_delta_tempo;
    Button m_b_aplicar;
    cine m_obj_exec;



    public void inicia (cine oe) {

	m_obj_exec = oe;
        setLayout (new FlowLayout (FlowLayout.CENTER));
	add (new Label ("massa:") );
	m_e_massa = new TextField ("2", 2);
        add (m_e_massa);
	add (new Label ("kg   fora:") );
	m_e_forca = new TextField ("4", 2);
        add (m_e_forca);
	add (new Label ("N   delta tempo:") );
	m_e_delta_tempo = new TextField ("1", 2);
        add (m_e_delta_tempo);
	add (new Label ("s   ") );
        m_b_aplicar = new Button ("tempo >");
	add (m_b_aplicar);
        m_b_aplicar.addActionListener (this);
    }



    public void actionPerformed (ActionEvent e) {
	Double odelta = new Double (m_e_delta_tempo.getText ());
	Double oforca = new Double (m_e_forca.getText ());
	Double omassa = new Double (m_e_massa.getText ());
	m_obj_exec.altera_estado (odelta.doubleValue (),
				  oforca.doubleValue (),
				  omassa.doubleValue ());
    }
}



class area_desenho extends Component {



    corpo_fisico m_corpo;



    public Dimension getPreferredSize () {
        return new Dimension (2000, 100);
    }



    public void inicia (corpo_fisico c) {
	m_corpo = c;
    }



    public void exibe () {
	repaint ();
    }



    public void paint (Graphics g) {
        int mx = getSize().width;
        int my = getSize().height;
	g.setColor (Color.white);
	g.fillRect (0, 0, mx, my);
	g.setColor (Color.black);
	g.drawLine (0, 0, 0, my-1);
	g.drawLine (0, 0, mx-1, 0);
	g.drawLine (mx-1, 0, mx-1, my-1);
	g.drawLine (0, my-1, mx-1, my-1);
	g.drawString ("(cada ponto na tela equivale a um metro)", 10, 80);
	m_corpo.exibe (g);
    }
}
    


class corpo {



    double m_pos_x [] = new double [100];
    double m_pos_y [] = new double [100];
    int m_num_pos = 0;



    public void inicia (double x, double y) {
	m_num_pos = 0;
	def_pos (x, y);
    }



    public void def_pos (double x, double y) {
	m_pos_x [m_num_pos] = x;
	m_pos_y [m_num_pos] = y;
	m_num_pos ++;
	if (m_num_pos >= 100) m_num_pos = 0;
    }



    public void exibe (Graphics gr) {
	for (int c = 0; c < m_num_pos; c++) {
	    int x = (int) m_pos_x [c];
	    int y = (int) m_pos_y [c];
	    if (c == m_num_pos - 1) {
		gr.setColor(Color.red);
		Integer ix = new Integer (x);
		gr.drawString (ix.toString () + "m", x + 5, 25);
	    }
	    else
		gr.setColor(Color.black);
	    gr.drawLine (x-2, y-2, x+2, y+2);
	    gr.drawLine (x+2, y-2, x-2, y+2);
	}
    }
}



class corpo_fisico extends corpo {



    double m_tempo_inicial = 0;
    double m_forca = 4;
    double m_massa = 2;
    double m_aceleracao = 0;
    double m_velocidade_inicial = 0;
    double m_velocidade = 0;
    double m_posicao_inicial = 0;
    double m_posicao = 0;



    public void altera_estado (double tempo) {
	
	double delta_tempo = tempo - m_tempo_inicial;
	m_aceleracao = m_forca / m_massa;
	m_velocidade = m_aceleracao * delta_tempo + m_velocidade_inicial;
	m_posicao = m_aceleracao * Math.pow (delta_tempo, 2) / 2 + m_velocidade_inicial * delta_tempo + m_posicao_inicial;
	double y = 0;
	if (m_num_pos != 0)
	    y = m_pos_y [m_num_pos - 1];
	def_pos (m_posicao, y);
	m_tempo_inicial = tempo;
	m_velocidade_inicial = m_velocidade;
	m_posicao_inicial = m_posicao;
    }



    public void def_forca (double v) {
	m_forca = v;
    }



    public void def_massa (double v) {
	m_massa = v;
    }
}



public class cine extends java.applet.Applet {



    painel_controles m_controles;
    area_desenho m_desenho;
    double m_tempo = 0;
    corpo_fisico m_ponto;



    public void init () {
	m_ponto = new corpo_fisico ();
	m_ponto.inicia (0.0, 50.0);
	m_tempo = 0;

	setLayout (new BorderLayout ());

	m_controles = new painel_controles (); 
	m_controles.inicia (this);
	add ("South", m_controles);

	m_desenho = new area_desenho ();
	m_desenho.inicia (m_ponto);

        ScrollPane rolo = new ScrollPane (ScrollPane.SCROLLBARS_AS_NEEDED);
        rolo.add (m_desenho);
        Adjustable vadjust = rolo.getVAdjustable ();
        Adjustable hadjust = rolo.getHAdjustable ();
        hadjust.setUnitIncrement (10);
        vadjust.setUnitIncrement (10);
        add ("Center", rolo);
    }



    public void destroy() {
        remove (m_controles);
        remove (m_desenho);
    }



    public void altera_estado (double dt, double f, double m) {
	m_tempo += dt;
	m_ponto.def_forca (f);
	m_ponto.def_massa (m);
	m_ponto.altera_estado (m_tempo);
	m_desenho.exibe ();
    }



    public String getAppletInfo() {
        return "Desenha um objeto em movimento.";
    }
}
