/*
 * Desenha um objeto em MRUV.
 * Usa controles grficos para ajustar parmetros.
 * Alteraes nos parmetros alteram coerentemente a trajetria.
 */



import java.awt.event.*;
import java.awt.*;
import java.lang.*;



class corpo {



    double m_pos_x [] = new double [100];
    double m_pos_y [] = new double [100];
    int m_num_pos = 0;



    public void inicia (double x, double y) {
	m_num_pos = 0;
	def_pos (x, y);
    }



    public void def_pos (double x, double y) {
	m_pos_x [m_num_pos] = x;
	m_pos_y [m_num_pos] = y;
	m_num_pos ++;
	if (m_num_pos >= 100) m_num_pos = 0;
    }



    public void exibe (Graphics gr) {
	for (int c = 0; c < m_num_pos; c++) {
	    int x = (int) m_pos_x [c];
	    int y = (int) m_pos_y [c];
	    if (c == m_num_pos - 1)
		gr.setColor(Color.red);
	    else
		gr.setColor(Color.black);
	    gr.drawLine (x-2, y-2, x+2, y+2);
	    gr.drawLine (x+2, y-2, x-2, y+2);
	}
    }
}



class corpo_fisico extends corpo {



    double m_tempo_inicial = 0;
    double m_forca = 4;
    double m_massa = 2;
    double m_aceleracao = 0;
    double m_velocidade_inicial = 0;
    double m_velocidade = 0;
    double m_posicao_inicial = 0;
    double m_posicao = 0;



    public void altera_estado (double tempo) {
	
	double delta_tempo = tempo - m_tempo_inicial;
	m_aceleracao = m_forca / m_massa;
	m_velocidade = m_aceleracao * delta_tempo + m_velocidade_inicial;
	m_posicao = m_aceleracao * Math.pow (delta_tempo, 2) / 2 + m_velocidade_inicial * delta_tempo + m_posicao_inicial;
	double y = 0;
	if (m_num_pos != 0)
	    y = m_pos_y [m_num_pos - 1];
	def_pos (m_posicao, y);
	m_tempo_inicial = tempo;
	m_velocidade_inicial = m_velocidade;
	m_posicao_inicial = m_posicao;
    }



    public void def_forca (double v) {
	m_forca = v;
    }



    public void def_massa (double v) {
	m_massa = v;
    }
}



public class cine extends java.applet.Applet implements ActionListener {



    TextField m_e_massa;
    TextField m_e_forca;
    TextField m_e_delta_tempo;
    Button m_b_aplicar;
    double m_tempo;
    corpo_fisico m_ponto;



    public void init () {
	m_ponto = new corpo_fisico ();
	m_ponto.inicia (0.0, 50.0);
	m_tempo = 0;
        setLayout (new FlowLayout (FlowLayout.RIGHT));
	add (new Label ("m:") );
	m_e_massa = new TextField ("2", 2);
        add (m_e_massa);
	add (new Label ("f:") );
	m_e_forca = new TextField ("4", 2);
        add (m_e_forca);
	add (new Label ("dt:") );
	m_e_delta_tempo = new TextField ("1", 2);
        add (m_e_delta_tempo);
        m_b_aplicar = new Button ("+");
	add (m_b_aplicar);
        m_b_aplicar.addActionListener (this);
    }



    public void actionPerformed (ActionEvent e) {
	if (e.getSource() == m_b_aplicar) {
	    Double odelta = new Double (m_e_delta_tempo.getText ());
	    Double oforca = new Double (m_e_forca.getText ());
	    Double omassa = new Double (m_e_massa.getText ());
	    m_tempo += odelta.doubleValue ();
	    m_ponto.def_forca (oforca.doubleValue ());
	    m_ponto.def_massa (omassa.doubleValue ());
	    m_ponto.altera_estado (m_tempo);
	    repaint ();
	}
    }



    public void paint (Graphics g) {
	g.drawLine (0, 0, 0, 99);
	g.drawLine (0, 0, 99, 0);
	g.drawLine (99, 0, 99, 99);
	g.drawLine (0, 99, 99, 99);
	g.setColor(Color.white);
	g.fillRect (0, 0, 99, 99);
	m_ponto.exibe (g);
    }



    public String getAppletInfo() {
        return "Desenha um objeto em movimento.";
    }
}
